import { NetplayInput } from "./types";
import { TouchControl } from "./touchcontrols";
export declare class DefaultInput extends NetplayInput<DefaultInput> {
    pressed: {
        [key: string]: boolean;
    };
    mousePosition?: {
        x: number;
        y: number;
    };
    touches: Array<{
        x: number;
        y: number;
    }>;
    touchControls?: {
        [name: string]: any;
    };
}
export declare class DefaultInputReader {
    canvas: HTMLCanvasElement;
    PRESSED_KEYS: {};
    mousePosition: {
        x: number;
        y: number;
    } | null;
    mouseDelta: {
        x: number;
        y: number;
    } | null;
    touches: Array<{
        x: number;
        y: number;
    }>;
    touchControls: {
        [name: string]: TouchControl;
    };
    getCanvasScale(): {
        x: number;
        y: number;
    };
    projectClientPosition(clientX: number, clientY: number): {
        x: number;
        y: number;
    };
    constructor(canvas: HTMLCanvasElement, pointerLock: boolean, touchControls: {
        [name: string]: TouchControl;
    });
    updateMousePosition(event: MouseEvent): void;
    updateTouches(event: TouchEvent): void;
    getInput(): DefaultInput;
}
